// Scripting in this file by Red Shifter

$AlundraZposA = "50";
$AlundraZposB = "102";
$AlundraGen = nameToId("LavaGen");
$AlundraWater = nameToId("Lavablock");

package AlundraScript {
 
 function Generator::onEnabled(%data, %obj, %prevState)
 {
    Parent::onEnabled(%data, %obj, %prevState);
    if (%obj == $AlundraGen) {
       %obj = $AlundraWater;
       %a = getWord(%obj.position, 0);
       %b = getWord(%obj.position, 1);
       %obj.position = %a SPC %b SPC $AlundraZPosA;
       %obj.setTransform(%obj.getTransform());
    }
 }
 
 function Generator::onDisabled(%data, %obj, %prevState)
 {
    Parent::onDisabled(%data, %obj, %prevState);
    if (%obj == $AlundraGen) {
       %obj = $AlundraWater;
       %a = getWord(%obj.position, 0);
       %b = getWord(%obj.position, 1);
       %obj.position = %a SPC %b SPC $AlundraZPosB;
       %obj.setTransform(%obj.getTransform());
    }
 }

 function DefaultGame::gameOver(%game)
 {
    // Default gameover script shutdown routine.
    deactivatePackage(AlundraScript);
    Parent::gameOver(%game);
 }
};
activatePackage(AlundraScript);
